.gba
.open "zm.gba","WaterFlying.gba",0x8000000
;by:JumZhu.Diwa

.definelabel SamusData,30013d4h
.definelabel PlaySound,8002A18h
.definelabel PlaySound2,8002B20h	
.definelabel StunSprite,8011280h	
.definelabel FrozenRoutine,800FFE8h	
.definelabel DeathFireWorks,8011084h	
.definelabel MainSpriteDateStart,0x82B0D68	
.definelabel CheckNoDeath,8010798h	
.definelabel CheckDropDisappear,80108B0h 	
.definelabel CheckRange2,800FE48h	
.definelabel SetTheDirection,800F8B0h	
.definelabel SpriteAiStart,0x875e8c0
.definelabel WaterFlyingID,12h					;Which sprite to replace
.definelabel CurrSprite,3000738h
.definelabel SpriteData,30001ACh
.definelabel SpriteGfxPointers,0x875EBF8
.definelabel SpritePalPointers,0x875EEF0
.org 0x80111CC
	.db 0xFF      ;使死亡烟花例程11084可以播放所有的特效

.org 0x8760D38

WaterFlyingGfx:
    .import "WaterFlying.gfx.lz"
.align	
WaterFlyingPal:
    .import "WaterFlying.palette"
.align	
.org SpriteAiStart + (WaterFlyingID * 4)
    .word WaterFlyingMain + 1
	
.org SpriteGfxPointers + (WaterFlyingID - 0x10) * 4
    .word WaterFlyingGfx

.org SpritePalPointers + (WaterFlyingID - 0x10) * 4
    .word WaterFlyingPal
	
.org 0x8304054
WaterFlying0:                        ;基础的设置
    ldr     r3,=CurrSprite                            	
    ldr     r0,=0FFE4h                              	
    strh    r0,[r3,0Ah]                             	
    mov     r0,1Ch                                  	
    strh    r0,[r3,0Ch]                             	
    ldr     r0,=0FFE8h                              	
    strh    r0,[r3,0Eh]                             	
    mov     r0,18h                                  	
    strh    r0,[r3,10h]  ;四面分界                           	
    mov     r0,r3                                   	
    add     r0,27h                                  	
    mov     r1,0Ah       ;300075f写入ah                          	
    strb    r1,[r0]                                 	
    add     r0,1h                                   	
    strb    r1,[r0]      ;3000760写入ah                             	
    mov     r1,r3                                   	
    add     r1,29h       ;3000761写入0ch                           	
    mov     r0,0Ch                                  	
    strb    r0,[r1]                                 	
    add     r1,4h                                   	
    mov     r0,1h        ;偏移2D写入1                            	
    strb    r0,[r1]                                 	
    ldr     r2,=MainSpriteDateStart                            	
    ldrb    r1,[r3,1Dh]                             	
    lsl     r0,r1,3h                                	
    add     r0,r0,r1                                	
    lsl     r0,r0,1h                                	
    add     r0,r0,r2     ;ID的18倍加偏移值                            	
    ldrh    r0,[r0]                                 	
    strh    r0,[r3,14h]   ;写入血量                          	
    ldrh    r1,[r3,2h]                              	
    sub     r1,20h        ;垂直坐标上移半格                          	
    strh    r1,[r3,2h]                              	
    ldrh    r0,[r3,4h]                              	
;    add     r0,20h        ;水平坐标右移半格                           	
;    strh    r0,[r3,4h]                              	
    strh    r1,[r3,6h]    ;备份XY坐标                         	
    strh    r0,[r3,8h]                              	
    bx      r14                                     	
.pool

//////////////////////////////////////////////////////////////////
WaterFlying1:                         ;不见的状态的设置         	
    ldr     r3,=CurrSprite                           	
    mov     r0,r3                                   	
    add     r0,25h                                  	
    mov     r2,0h                                   	
    strb    r2,[r0]       ;属性写入0                           	
    mov     r1,r3                                   	
    add     r1,24h                                  	
    mov     r0,2h         ;pose写入9h                          	
    strb    r0,[r1]                                 	
    ldr     r0,=WaterFlyinyUpMoveOAM                            	
    str     r0,[r3,18h]                           	
    mov     r0,0h                                   	
    strh    r2,[r3,16h]                             	
    strb    r0,[r3,1Ch]                             	
    ldrh    r0,[r3]                                 	
    ldr     r2,=8004h                               	
    mov     r1,r2                                   	
    orr     r0,r1         ;取向 orr 8004h  看不见                        	
    strh    r0,[r3]                                 	
    mov     r1,r3                                   	
    add     r1,21h                                  	
    mov     r0,1h                                   	
    strb    r0,[r1]       ;偏移21,图层在砖图前-                        	
    bx      r14    	
.pool

 
///////////////////////////////////////////////////////////////////////////                               
WaterFlying2:                            ;一般没有出现的时候
    push    r4,r5,r14                               	
 ;   add     sp,-0Ch                                 	
    ldr     r4,=CurrSprite                            	                            	                               	                         	
    bl      CheckDropDisappear      ;检查是否有掉落                        	
    cmp     r0,0h                                   	
    bne     @@end                             	
    mov     r1,r4                                   	
    add     r1,2Dh                                  	
    ldrb    r0,[r1]                                 	
    cmp     r0,0h      ;再生值为0跳转                            	
    beq     @@respawn                               	
    sub     r0,1h                                   	
    strb    r0,[r1]    ;否则减1写入然后结束                             	
    b       @@end      ;用来延迟精灵多久再生	
.pool
	
@@respawn:                              	
    ldr     r0,=SamusData                             	
    ldrh    r1,[r0,14h]   ;人物垂直坐标                          	
    ldrh    r3,[r0,12h]   ;人物水平坐标                          	
    ldrh    r0,[r4,2h]    ;精灵垂直坐标                          	
    ldrh    r2,[r4,4h]    ;精灵水平坐标                          	
    sub     r0,1Eh        ;人物垂直坐标大于精灵垂直坐标上IEh                          	
    cmp     r1,r0         ;人物在精灵Y坐标加1E的下面                         	
    bgt     @@end         ;大于则结束 也就是没有达到一定高度                      	
    cmp     r2,r3                                   	
    bls     @@rightsprite ;如果人物在精灵右边则跳转                         	
    sub     r0,r2,r3      ;精灵与人物的距离                          	
    b       @@leftsprite                                	
.pool
	
@@rightsprite:                           	
    sub     r0,r3,r2      ;精灵与人物的距离	
@@leftsprite:                         	
    cmp     r0,24h                                  	
    ble     @@end         ;距离太近则结束 基本是在精灵上                       	
    mov     r1,0A0h                                 	
    lsl     r1,r1,1h                                	
    mov     r0,r1         ;140h                          	
    bl      CheckRange2 ;检查精灵是否这个范围内                               	
    cmp     r0,1h                                   	
    bne     @@end         ;不为1结束                       	
    ldr     r5,=CurrSprite                            	
    ldr     r0,=SamusData                            	
    ldrh    r0,[r0,14h]   ;读取人物的Y坐标                          	
    strh    r0,[r5,12h]   ;写入偏移12                          	
    mov     r1,r5                                   	
    add     r1,24h                                  	
    mov     r0,3h        ;pose写入3h                          	
    strb    r0,[r1]                                 	
    mov     r0,r5                                   	
    add     r0,2Ch                                  	
    mov     r4,2h         ;偏移2C写入2                         	
    strb    r4,[r0]                               	
    ldrh    r1,[r5]                                 	
    ldr     r0,=7FFBh                               	
    and     r0,r1         ;去掉精灵的不显示取向                         	
    strh    r0,[r5]                                 	
    bl      SetTheDirection ;根据人物位置而改变精灵的面向                              	
;    ldrh    r0,[r5]                                 	
;    and     r4,r0         ;检查是否在屏幕内                          	
;    cmp     r4,0h                                   	
;    beq     @@end                               	
;    ldr     r0,=183h                                	
;    bl      8002A18h      ;播放嗡嗡声	
                              	
@@end:                                	
 ;   add     sp,0Ch                               	
    pop     r4,r5                                   	
    pop     r0                                      	
    bx      r0    	
.pool
/////////////////////////////////////////////////////////////////////////////	
WaterFlying3:
    push    r14                                     	
    ldr     r1,=CurrSprite                            	
    ldrh    r0,[r1,2h]                              	
    sub     r0,2h                                   	
    strh    r0,[r1,2h]   ;垂直坐标上移2h                          	
    mov     r2,r1                                   	
    add     r2,2Ch                                  	
    ldrb    r0,[r2]      ;读取偏移的2C的值                           	
    mov     r3,r1                                   	
    cmp     r0,0h                                   	
    beq     @@pass                               	
    sub     r0,1h        ;不为0则减1再写入                           	
    strb    r0,[r2]                                 	
    lsl     r0,r0,18h                               	
    cmp     r0,0h        ;减1后不为0则结束                          	
    bne     @@end                                	
    add     r1,25h       ;为0则属性写入4h                          	
    mov     r0,4h                                   	
    b       @@come                               	
.pool
	
@@pass:                              	
    ldr     r0,=SamusData                            	
    ldrh    r1,[r3,12h]  ;读取要上升的Y坐标                         	
    mov     r2,r0                                   	
    ldrh    r0,[r2,14h]  ;读取人物的Y坐标                           	
    cmp     r1,r0                                   	
    bcs     @@Goto     ;要上升的坐标仍然在人物的Y坐标之下则跳转	
;--------------------------------------人物的当前坐标在定位Y坐标之下                       	
    ldrh    r1,[r2,14h]  ;人物的Y坐标                           	
    ldrh    r0,[r3,6h]   ;和精灵的备份Y坐标                           	
    sub     r0,80h       ;精灵生产坐标处向上两格的高度                           	
    cmp     r1,r0        ;人物的坐标比较精灵生产出向上两格                           	
    ble     @@Goto     ;人物如果高于精灵原坐标向上两格                           	
    ldrh    r0,[r3,12h]  ;读取要上升的Y坐标                           	
    b       @@Peer                                	
.pool
	
@@Goto:                              	
    ldrh    r0,[r2,14h]  ;读取人物的Y坐标 
@@Peer:	
    sub     r0,64h       ;向上64h                           	
    ldrh    r1,[r3,2h]   ;读取精灵的当前Y坐标                           	
    cmp     r0,r1                                   	
    ble     @@end        ;人物仍在上面则结束                               	
    mov     r1,r3                                   	
    add     r1,24h       ;否则pose写入4                          	
    mov     r2,0h                                   	
    mov     r0,4h                                  	
    strb    r0,[r1]                                 	
    add     r1,8h                                   	
    mov     r0,0Ah                                  	
    strb    r0,[r1]      ;偏移2c写入0Ah                            	
    ldr     r0,=WaterFlyinyMoveOAM ;写入向前飞行的OAM                           	
    str     r0,[r3,18h]                             	
    mov     r0,0h                                   	
    strh    r2,[r3,16h]                             	
    strb    r0,[r3,1Ch]                             	
    sub     r1,0Bh                                  	
    mov     r0,1h        ;图层的先后写为1	
@@come:                                 	
    strb    r0,[r1]      ;属性写入4	
	
@@end:                                	
    pop     r0                                      	
    bx      r0                                      	
.pool
////////////////////////////////////////////////////////////////	
	
ReSpawnSprite:                          	
    push    r4,r5,r14                               	
    ldr     r5,=CurrSprite                            	
    ldrb    r0,[r5,1Dh]                             	
    cmp     r0,0A0h                                 	
    bne     @@Normal	
;===============================A0的设置                                	
    mov     r0,0h                                   	
    strh    r0,[r5]      ;直接消失                          	
    b       @@end                                	
.pool
	
@@Normal:                              	
    ldrh    r0,[r5,6h]   ;读取备份的Y坐标                            	
    mov     r4,0h                                   	
    strh    r0,[r5,2h]   ;写入当前的Y坐标                            	
    ldrh    r0,[r5,8h]   ;读取备份的x坐标                         	
    strh    r0,[r5,4h]   ;同样                           	
    bl      WaterFlying1 ;调用pose 1初始化不显示的精灵                           	
    mov     r1,r5                                   	
    add     r1,2Dh                                  	
    mov     r0,3Ch                                  	
    strb    r0,[r1]      ;偏移2D写入3C                            	
    ldr     r2,=MainSpriteDateStart                            	
    ldrb    r1,[r5,1Dh]                             	
    lsl     r0,r1,3h                                	
    add     r0,r0,r1                                	
    lsl     r0,r0,1h                                	
    add     r0,r0,r2                                	
    ldrh    r0,[r0]                                 	
    strh    r0,[r5,14h]  ;重新写入满血量                           	
    mov     r0,r5                                   	
    add     r0,2Bh                                  	
    strb    r4,[r0]      ;击晕时间写入0>>>                            	
    sub     r0,0Bh                                  	
    strb    r4,[r0]      ;调色板写入0号                           	
    add     r0,13h                                  	
    strb    r4,[r0]      ;偏移33写入0:>>>>                           	
    add     r0,1h                                   	
    strb    r4,[r0]      ;击打变色值写入1                           	
    mov     r1,r5                                   	
    add     r1,26h                                  	
    mov     r0,1h                                   	
    strb    r0,[r1]      ;待机值写入1 自动减                           	
    mov     r0,r5                                   	
    add     r0,30h       ;冰冻时间写入0                           	
    strb    r4,[r0] 	
	
@@end:                                	
    pop     r4,r5                                   	
    pop     r0                                      	
    bx      r0                                      	
.pool
///////////////////////////////////////////////////////////////	
WaterFlying4:
    push    r4,r5,r14                               	
    ldr     r1,=CurrSprite                            	
    mov     r2,r1                                   	
    add     r2,2Ch     ;读取偏移2C的值                            	
    ldrb    r0,[r2]                                 	
    mov     r4,r1                                   	
    cmp     r0,0h                                   	
    beq     @@TimerIsZero                                	
    sub     r0,1h      ;不为0的话减1再写入                            	
    strb    r0,[r2]                                 	
    lsl     r0,r0,18h                               	
    lsr     r5,r0,18h                               	
    cmp     r5,0h                                   	
    bne     @@end      	
	
;为1的时候                          	                             	
    mov     r0,r4                                   	
    add     r0,2Dh                                  	
    strb    r5,[r0]    ;偏移2D写入0                               	
    b       @@end                                	
.pool 	
	
@@TimerIsZero:                             	
    mov     r1,r4                                   	
    add     r1,2Dh                                   	
    ldrb    r0,[r1]    ;读取偏移2D的值                             	
    add     r0,1h                                   	
    strb    r0,[r1]    ;再生值加1写入                                	
    ldrh    r1,[r4]                                 	
    mov     r0,40h                                  	
    and     r0,r1                                   	
    cmp     r0,0h         ;检查面向                            	
    beq     @@left                                	
    ldrh    r2,[r4,4h]    ;精灵水平                          	
    ldr     r0,=SamusData                            	
    ldrh    r0,[r0,12h]   ;人物水平                          	
    sub     r0,r2,r0      ;人物水平减去精灵水平                          	
    mov     r1,80h                                  	
    lsl     r1,r1,3h                                	
    cmp     r0,r1         ;和400h相比,ah格?                              	
    bgt     @@goto        ;两者的距离大于10格                        	
    mov     r0,80h                                  	
    lsl     r0,r0,8h                                	
    and     r0,r2         ;精灵水平坐标达到了8000h?                          	
    cmp     r0,0h                                   	
    bne     @@goto          
    ldrh    r0,[r4,16h]    ;读取动画
    cmp     r0,0h
	bhi     @@ContrieCheckRight
	mov     r1,4h          ;常速移动
	b       @@CalRight
@@ContrieCheckRight:
    cmp     r0,1h
    bhi     @@AccMoveRight
    mov     r1,1h
    b       @@CalRight
@@AccMoveRight:
    mov     r1,8h          ;高速移动	
@@CalRight:	
    mov     r0,r2                                   	
    add     r0,r1          ;移动速度加                          	
    b       @@SpeedWrite                                	
.pool	
	
@@left:                              	
    ldr     r0,=SamusData                            	
    ldrh    r0,[r0,12h]    ;人物水平坐标                         	
    ldrh    r2,[r4,4h]     ;精灵水平坐标                         	
    sub     r0,r0,r2                                	
    mov     r1,80h                                  	
    lsl     r1,r1,3h                                	
    cmp     r0,r1                                   	
    bgt     @@goto                               	
    mov     r0,80h                                  	
    lsl     r0,r0,8h                                	
    and     r0,r2                                   	
    cmp     r0,0h                                   	
    beq     @@Pass 	
	
@@goto:                               	
    bl      ReSpawnSprite                                	
    b       @@end                                	
.pool
	
@@Pass:
    ldrh    r0,[r4,16h]    ;读取动画
    cmp     r0,0h
	bhi     @@ContrieCheckLeft
	mov     r1,4h          ;常速移动
	b       @@CalLeft
@@ContrieCheckLeft:
    cmp     r0,1h
    bhi     @@AccMoveLeft
    mov     r1,1h
    b       @@CalLeft
@@AccMoveLeft:
    mov     r1,8h          ;告诉移动	
@@CalLeft:	                              	
    mov     r0,r2                                   	
    sub     r0,r1          ;移动速度	
.pool
	
@@SpeedWrite:                               	
    strh    r0,[r4,4h]  ;写入移动的速度                            	                              	
@@end:                                	
    pop     r4,r5                                   	
    pop     r0                                      	
    bx      r0                 	
.pool
	
/////////////////////////////////////////////////////////////////////////////////////////	
WaterFlyingMain:
    push    r4,r14                                  	
    add     sp,-4h                                  	
    ldr     r1,=CurrSprite                            	
    mov     r3,r1                                   	
    add     r3,32h      ;300076a                            	
    ldrb    r2,[r3]                                 	
    mov     r4,2h                                   	
    mov     r0,r4                                   	
    and     r0,r2       ;检查碰撞属性是否为0                            	
    cmp     r0,0h                                   	
    beq     @@FrozenRoutineCheck
    mov     r0,0FDh                                 	
    and     r0,r2                                   	
    strb    r0,[r3]     ;不为0的话说清0?                            	
    ldrh    r1,[r1]                                 	
    mov     r0,r4                                   	
    and     r0,r1       ;2 and 3000738                            	
    cmp     r0,0h                                   	
    beq     @@FrozenRoutineCheck                                	
    mov     r0,0BCh 
	lsl 	r0,r0,1
    bl PlaySound2
	
@@FrozenRoutineCheck:                            	
    ldr     r4,=CurrSprite                            	
    mov     r0,r4                                   	
    add     r0,30h     ;检查冰冻时间                             	
    ldrb    r0,[r0]                                 	
    cmp     r0,0h      ;检查冰冻是否成立                             	
    beq     @@NoFrozenRoutine                                	
    bl      FrozenRoutine                                 	
    b       @Thend                                 	
.pool	
@@NoFrozenRoutine:                               	
    bl      StunSprite                                	
    cmp     r0,0h                                   	
    bne     @Thend                                	
    mov     r0,r4                                   	
    add     r0,24h                                  	
    ldrb    r0,[r0]                                 	
    cmp     r0,25h                                  	
    bhi     @OtherPose   ;pose如果大于25跳转                             	
    lsl     r0,r0,2h                                	
    ldr     r1,=WaterFlyingPoseTable                            	
    add     r0,r0,r1                                	
    ldr     r0,[r0]                                 	
    mov     r15,r0 	
.pool	
WaterFlyingPoseTable:
	.word FlyingPose0 	
    .word FlyingPose1 	
	.word FlyingPose2 
    .word FlyingPose3 	
	.word FlyingPose4 
;    .word FlyingPose5

FlyingPose0:
    bl WaterFlying0	    ;初始化
FlyingPose1:
    bl WaterFlying1     ;基本设置
FlyingPose2:
    bl WaterFlying2     
    b  @Thend	
FlyingPose3:
    bl WaterFlying3
    b  @Thend	
FlyingPose4:
    bl WaterFlying4
    b  @Thend
;FlyingPose5:
;    bl WaterFlying5
 ;   b  @Thend	

@OtherPose:  	
    ldr     r0,=CurrSprite                            	
    ldrh    r1,[r0,2h]                              	
    ldrh    r2,[r0,4h]                              	
    mov     r0,36h                                  	
    str     r0,[sp]                                 	
    mov     r0,1h                                   	
    mov     r3,0h                                   	
    bl      DeathFireWorks                                	
    bl      ReSpawnSprite
	ldrh 	r0,[r4]
	mov		r1,2h
	and		r0,r1
	cmp		r0,0h
	beq		@Thend
    ldr     r0,=151h
    bl      PlaySound2	
	
@Thend:                                	
    add     sp,4h                                   	
    pop     r4                                      	
    pop     r0                                      	
    bx      r0                                      	
.pool	
	
.align	
WaterFlyinyUpMoveOAM:	
    .word WaterFlyinyUpMoveOAM1	
    .word 0x3	
	.word WaterFlyinyUpMoveOAM2
	.word 0x3
	.word WaterFlyinyUpMoveOAM3
	.word 0x3
	.word 0,0
	
WaterFlyinyUpMoveOAM1:	
    .halfword 0x1	
	.halfword 0xf8,0x41f8,0x8200
	
WaterFlyinyUpMoveOAM2:	
    .halfword 0x1	
    .halfword 0xf8,0x41f8,0x8202	
	
WaterFlyinyUpMoveOAM3:	
    .halfword 0x1	
    .halfword 0xf8,0x41f8,0x8204	
	
.align	
WaterFlyinyMoveOAM:	
    .word WaterFlyinyUpMoveOAM2          ;常速移动	
    .word 0x40	 
	.word WaterFlyinyWillAccOAM
	.word 0xf
	.word WaterFlyinyFastSpeedMoveOAM 
    .word 0x40	
    .word 0,0	
	
WaterFlyinyWillAccOAM:	
    .halfword 0x1	
	.halfword 0xf8,0x41f8,0x8206
	
WaterFlyinyFastSpeedMoveOAM:	
    .halfword 0x1	
    .halfword 0xf8,0x41f8,0x8208	

.pool
.close
	
